From a71c90f556ba143335d9631ebbdf96b7120c6d1d Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Thu, 29 Jan 2026 20:24:54 +0700
Subject: [PATCH v9 15/26] Fixing memory leak during data flush in COPY BINARY
 test

---
 src/bin/pgbench/pgbench.c | 26 ++++++++++++++++----------
 1 file changed, 16 insertions(+), 10 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 6f42438d970..8eca537b718 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -871,7 +871,7 @@ static bool socket_has_input(socket_set *sa, int fd, int idx);
 
 /* callback used to build rows for COPY during data loading */
 typedef void (*initRowMethod)		(PQExpBufferData *sql, int64 curr);
-typedef void (*initRowMethodBin)	(PGconn *con, PGresult *res, int64_t curr, int32_t parent);
+typedef void (*initRowMethodBin)	(PGconn *con, int64_t curr, int32_t parent);
 
 /* callback functions for our flex lexer */
 static const PsqlScanCallbacks pgbench_callbacks = {
@@ -5345,13 +5345,18 @@ sendBinaryCopyTrailer(PGconn *con)
  * Flashes current buffer over network if needed
  */
 static void
-flushBuffer(PGconn *con, PGresult *res, int16_t row_len)
+flushBuffer(PGconn *con, int16_t row_len)
 {
+	PGresult *res;
+
 	if (bin_copy_buffer_length + row_len > BIN_COPY_BUF_SIZE)
 	{
+		res = PQgetResult(con);
 		/* flush current buffer */
 		if (PQresultStatus(res) == PGRES_COPY_IN)
 			PQputCopyData(con, (char *) bin_copy_buffer, bin_copy_buffer_length);
+		else
+			pg_fatal("It is NOT a COPY command that is currently running");
 		bin_copy_buffer_length = 0;
 	}
 }
@@ -5360,7 +5365,7 @@ flushBuffer(PGconn *con, PGresult *res, int16_t row_len)
  * Sends current branch row to buffer
  */
 static void
-initBranchBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
+initBranchBinary(PGconn *con, int64_t curr, int32_t parent)
 {
 	/*
 	 * Each row of branch table has following extra bytes:
@@ -5369,7 +5374,7 @@ initBranchBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 	 */
 	int16_t	max_row_len =  35 + 2 + 4*3; /* max row size is 35 */
 
-	flushBuffer(con, res, max_row_len);
+	flushBuffer(con, max_row_len);
 
 	addColumnCounter(2);
 
@@ -5381,7 +5386,7 @@ initBranchBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
  * Sends current teller row to buffer
  */
 static void
-initTellerBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
+initTellerBinary(PGconn *con, int64_t curr, int32_t parent)
 {
 	/*
 	 * Each row of tellers table has following extra bytes:
@@ -5390,7 +5395,7 @@ initTellerBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 	 */
 	int16_t	max_row_len =  40 + 2 + 4*4; /* max row size is 40 */
 
-	flushBuffer(con, res, max_row_len);
+	flushBuffer(con, max_row_len);
 
 	addColumnCounter(3);
 
@@ -5403,7 +5408,7 @@ initTellerBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
  * Sends current account row to buffer
  */
 static void
-initAccountBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
+initAccountBinary(PGconn *con, int64_t curr, int32_t parent)
 {
 	/*
 	 * Each row of accounts table has following extra bytes:
@@ -5412,7 +5417,7 @@ initAccountBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 	 */
 	int16_t	max_row_len = 250 + 2 + 4*4; /* max row size is 250 for int64 */
 
-	flushBuffer(con, res, max_row_len);
+	flushBuffer(con, max_row_len);
 
 	addColumnCounter(3);
 
@@ -5462,10 +5467,10 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	for (int64_t i = start; i < start + base; i++)
 	{
-		res = PQgetResult(con);
-		init_row(con, res, i, base);
+		init_row(con, i, base);
 	}
 
+	res = PQgetResult(con);
 	if (PQresultStatus(res) == PGRES_COPY_IN)
 		PQputCopyData(con, (char *) bin_copy_buffer, bin_copy_buffer_length);
 	else
@@ -5474,6 +5479,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	sendBinaryCopyTrailer(con);
 
+
 	res = PQgetResult(con);
 	if (PQresultStatus(res) == PGRES_COPY_IN)
 	{
-- 
2.43.0

